DarkMode = {}

local ClickX = false;
local ClickY = false;
local DarkLevel = 0;

function DarkMode:DifferenceAlgoritm(XCount, XMin, XMax, YMin, YMax)
    local XDiff = XMax - XMin
    local YDiff = YMax - YMin

    local PrcentDiff = ((XCount - XMin) / XDiff) * 100
    local Out = (PrcentDiff / 100) * YDiff

    Out = Out + YMin

    return Out
end

function DarkMode:GetDarkLevel()
    return DarkLevel
end

function DarkMode:update()

    if DarkMode:GetDarkLevel() > 0 then
        setTextColor(0, 0, 0, DarkMode:DifferenceAlgoritm(DarkMode:GetDarkLevel(), 0, 100, 0.7, 0.95))
        renderText(-1.2, -6.1, 23.840000000005, "-")
    end

    if Input.isKeyPressed(Input.KEY_rctrl) then
        if Input.isKeyPressed(Input.KEY_pageup) and ClickX == false then
            ClickX = true
            DarkLevel = DarkLevel + 10
        end
        if Input.isKeyPressed(Input.KEY_pagedown) and ClickY == false then
            ClickY = true
            DarkLevel = DarkLevel - 10
        end

        if DarkLevel < 0 then DarkLevel = 0 end
        if DarkLevel > 100 then DarkLevel = 100 end

		local TextString = g_i18n:getText("text_Darkening") .. " " .. tostring(DarkLevel) .. "%"
		g_currentMission:addExtraPrintText(TextString);
    end

    if Input.isKeyPressed(Input.KEY_pageup) == false and ClickX == true then
        ClickX = false
    end
    if Input.isKeyPressed(Input.KEY_pagedown) == false and ClickY == true then
        ClickY = false
    end
end

function TextElementGetTextColorExtended(self)
    local ProvidedColor = self.textColor

    if self.disabled and not self.ignoreDisabled then
        ProvidedColor = self.textDisabledColor
    elseif self:getIsSelected() then
        ProvidedColor = self.textSelectedColor
    elseif self:getIsHighlighted() then
        ProvidedColor = self.textHighlightedColor
    else
        ProvidedColor = self.textColor
    end

    if DarkMode:GetDarkLevel() > 0 then
        ProvidedColor[4] = DarkMode:DifferenceAlgoritm(DarkMode:GetDarkLevel(), 0, 100, 1, 0.25)
    end

    return ProvidedColor
end

function DarkMode:loadMap(savegame)
    if DarkMode:HasSavegame() then DarkMode:LoadSavegame(); end;
    FSBaseMission.saveSavegame = Utils.appendedFunction(FSBaseMission.saveSavegame, DarkMode.SaveSavegame);
end

function DarkMode:HasSavegame()
    local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), g_currentMission.missionInfo.savegameIndex);
	end;
	savegameFolderPath = savegameFolderPath.."/"

    return fileExists(savegameFolderPath.."DarkMode.xml");
end
function DarkMode:LoadSavegame()
    local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), g_currentMission.missionInfo.savegameIndex);
	end;
	savegameFolderPath = savegameFolderPath.."/"

	local key = "DarkMode";

	if fileExists(savegameFolderPath.."DarkMode.xml") then
		local xmlFile = loadXMLFile(key, savegameFolderPath.."DarkMode.xml");
        DarkLevel = getXMLInt(xmlFile, key.."#DarkModeLevel");

		delete(xmlFile);
	end;
end;
function DarkMode:SaveSavegame()
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), g_currentMission.missionInfo.savegameIndex);
	end;
	savegameFolderPath = savegameFolderPath.."/"

	local key = "DarkMode";
	local xmlFile = createXMLFile(key, savegameFolderPath.."DarkMode.xml", key);

	setXMLInt(xmlFile, key.."#SaveVersion", 1);
    setXMLInt(xmlFile, key.."#DarkModeLevel", DarkLevel);

	saveXMLFile(xmlFile);
	delete(xmlFile);
end;

TextElement.getTextColor = Utils.overwrittenFunction(TextElement.getTextColor, TextElementGetTextColorExtended)
addModEventListener(DarkMode)
